-- Test order_campsite_type_options
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_campsite_type_options', array['integer[]']);
select function_lang_is('camper', 'order_campsite_type_options', array['integer[]'], 'sql');
select function_returns('camper', 'order_campsite_type_options', array['integer[]'], 'void');
select isnt_definer('camper', 'order_campsite_type_options', array['integer[]']);
select volatility_is('camper', 'order_campsite_type_options', array['integer[]'], 'volatile');
select function_privs_are('camper', 'order_campsite_type_options', array ['integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_options', array ['integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_campsite_type_options', array ['integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_campsite_type_options', array ['integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_option_i18n cascade;
truncate campsite_type_option cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, media_id, name, description, active, max_campers, bookable_nights)
values (3, 1, 2, 'Type A', '<p>A</p>', true, 4, '[1, 7]')
;

insert into campsite_type_option (campsite_type_option_id, campsite_type_id, name, range, per_night)
values (4, 3, '1', '[0, 10]', true)
     , (5, 3, '2', '[0, 10]', true)
     , (6, 3, '3', '[0, 10]', true)
     , (7, 3, '4', '[0, 10]', true)
     , (8, 3, '5', '[0, 10]', true)
;

select lives_ok(
	$$ select order_campsite_type_options('{6,8,7,4,5}') $$,
	'Should be able to sort campsite type options using their ID'
);

select bag_eq(
	$$ select campsite_type_option_id, position from campsite_type_option $$,
	$$ values (6, 1)
	        , (8, 2)
	        , (7, 3)
	        , (4, 4)
	        , (5, 5)
	$$,
	'Should have sorted all campsite type options.'
);

select *
from finish();

rollback;
